/*
   -   +  GapPoints
double iCustom(
   string symbol,          //    (NULL- )
   int timeframe,          // - (0- )
   "iOsMA.Gap",            //   
   //
   double fast_ema_period, //   EMA; .. (>1)    - (<1)
   double slow_ema_period, //   EMA; .. (>1)    - (<1)
   int signal_period,      //   SMA
   int applied_price,      //  :
                              // 0 - PRICE_CLOSE -   
                              // 1 - PRICE_OPEN -  
                              // 2 - PRICE_HIGH - .
                              // 3 - PRICE_LOW - .
                              // 4 - PRICE_MEDIAN -  ,(high+low)/2
                              // 5 - PRICE_TYPICAL -  ,(high+low+close)/3
                              // 6 - PRICE_WEIGHTED -   ,(high+low+close+close)/4
                              // 7 - 
   int GapPoints,          //     .
   //
   mode,                   // mode -    (0)
   int shift               // 
   ) 

==============

iCustom(NULL,0,"iOsMA.Gap",FastEMA,SlowEMA,SignalSMA,Price,GapPoints, 0,i);
*/

#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  Silver

//  
extern double FastEMA=12;
   double f0;
extern double SlowEMA=26;
   double s0;
extern int SignalSMA=9;
extern int Price=0;
extern int GapPoints=0; //     .
 int GapHours=8; //      (>0)    (<0)
 int History=0; // 0-  

double   OsMA[], 
         MACD[],
         Signal[]; 
double fper,sper; //  

void init() { 
   if(FastEMA>1) {f0=2/(1+FastEMA); fper=FastEMA;}
   else {f0=FastEMA; fper=(2-FastEMA)/FastEMA;}
   if(SlowEMA>1) {s0=2/(1+SlowEMA); sper=SlowEMA;}
   else {s0=FastEMA; sper=(2-SlowEMA)/SlowEMA;}
   
   IndicatorDigits(5);   
   string _sn="OsMA("+DoubleToStr(fper,2)+","+DoubleToStr(sper,2)+","+SignalSMA+")";
   IndicatorShortName(_sn);

   SetIndexBuffer(0,OsMA); 
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexLabel(0,_sn);

   IndicatorBuffers(3);
   SetIndexBuffer(1,MACD); 
   SetIndexBuffer(2,Signal); 
  }

void start() {
   int limit=Bars-IndicatorCounted()-1; 
   if(limit>1) limit=MathMin(Bars,History+(History==0)*Bars)-1;
   //  
   for(int i=limit; i>=0; i--) { 
      //  
      double c=iCustom(NULL,0,"KillGap",GapPoints,GapHours,Price, 0,i); 
      // MACD
      static double fm1,sm1; // EMAs previous
      if(i==limit && i>1) {fm1=c;sm1=c;} //  
      double fm0=f0*c+(1-f0)*fm1; // fast MA
      double sm0=s0*c+(1-s0)*sm1; // slow MA
      MACD[i]=fm0-sm0; // MACD
      // 
      if(i>0) {fm1=fm0; sm1=sm0;}
     }
   // Signal
   for(i=limit; i>=0; i--) Signal[i]=iMAOnArray(MACD,Bars,SignalSMA,0,MODE_SMA,i);
   // OsMA
   for(i=limit; i>=0; i--) OsMA[i]=MACD[i]-Signal[i];
  }

